#ifndef _LISTA_H_
#define _LISTA_H_

template<class T>
class Lista
{
private:
	class Elemento
	{
	public:
		Elemento()						{	pAnterior = pProximo = NULL;	}
		~Elemento()						{	}
		
		void setAnterior(Elemento* ele)	{	pAnterior = ele;	}
		Elemento* getAnterior()			{	return pAnterior;	}
		void setProximo(Elemento* ele)	{	pProximo = ele;		}
		Elemento* getProximo()			{	return pProximo;	}
		void setValor(T val)			{	valor = val;		}
		T getValor()					{	return valor;		}
	private:
		Elemento *pAnterior;
		Elemento *pProximo;
		T valor;
	};

	Elemento *pPrimeiro, *pAtual;

public:
	class Iterator
	{
	private:
		Elemento* pElem;
	public:
		Iterator()						{	}
		~Iterator()						{	}
		void operator ++(int)			{	pElem = pElem->getProximo();	}
		T operator *()					{	return pElem->getValor();		}
		void operator =(Elemento* ele)	{	pElem = ele;					}
        bool operator ==(Elemento* ele)	{	return (pElem == ele);			}
        bool operator !=(Elemento* ele)	{	return !(ele == pElem);			}
	};

public:
	Lista()								{	pPrimeiro = pAtual = NULL;		}
	~Lista()							{	/*limpar();*/					}
	void limpar()
	{
		Elemento *aux;
		Elemento *it = pPrimeiro;
		while( it != NULL )
		{
			aux = it;
			it = it->getProximo();
			delete aux;
		}
		pPrimeiro = pAtual = NULL;
	}
	void incluir(T valor)
	{
		Elemento *novo = new Elemento;
		novo->setValor( valor );
		if ( NULL == pPrimeiro )
		{
			pAtual = pPrimeiro = novo;
		}
		else
		{
			pAtual->setProximo( novo );
			novo->setAnterior( pAtual );
			pAtual = novo;
		}
	}

	int tamanho()
	{
		int tam = 0;
		Elemento *it = pPrimeiro;
		while (it != NULL)
		{
			tam ++;
			it = it->getProximo();
		}
		return tam;
	}
	
	Elemento* begin()					{	return pPrimeiro;				}
	Elemento* end()						{	return pAtual->getProximo();	}
	Elemento* rBegin()					{	return pAtual;					}
	Elemento* rEnd()					{	return pPrimeiro->getAnterior();}
};

#endif